import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'api_services.dart';


class CheckoutPaypalPage extends StatefulWidget {
  final String orderId;
  final String clientId;
  final String transactionId;
  final amount;
  final String merchandUserName;
  final String merchandPassword;
  final String sandbox;
  final String currency;
  final Function actionAfterProccess;

  const CheckoutPaypalPage(
      {Key? key,
        required this.orderId,
        required this.clientId,
        required this.transactionId,
        required this.amount,
        required this.merchandUserName,
        required this.merchandPassword,
        required this.sandbox,
        required this.currency,
        required this.actionAfterProccess,})
      : super(key: key);

  @override
  _CheckoutPageState createState() => _CheckoutPageState();
}

class _CheckoutPageState extends State<CheckoutPaypalPage> {
  late WebViewController _webViewController;

  String get initialUrl =>
      'https://hostedpages.payunit.net/#/mobilePayPal?amount=${widget.amount}&t_id=${widget.transactionId}&order_id=${widget.orderId}&currency=${widget.currency}&client_id=${widget.clientId}';
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        child: WebView(
          initialUrl: initialUrl,
          javascriptMode: JavascriptMode.unrestricted,
          onWebViewCreated: (webViewController) =>
          _webViewController = webViewController,
          onPageFinished: (String url) {
            if (url == initialUrl) {}
          },
          navigationDelegate: (NavigationRequest request) {
            if (request.url.startsWith('https://success.com')) {
              Navigator.pop(context);
              Navigator.of(context).pop();
              widget.actionAfterProccess(widget.transactionId, "SUCCESS");
            } else if (request.url.startsWith('https://cancel.com')) {
              Navigator.of(context).pop();
              Navigator.of(context).pop();
              widget.actionAfterProccess(widget.transactionId, "FAILED");
            }
            return NavigationDecision.navigate;
          },
        ),
      ),
    );
  }
}